using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using CMS.TreeEngine;
using CMS.GlobalHelper;
using CMS.CMSHelper;
using CMS.SiteProvider;
using CMS.LicenseProvider;
using CMS.EventLog;

public partial class CMSDesk_Content_Properties_security : CMSDeskPage
{
    protected CMS.TreeEngine.TreeNode node = null;
    protected int nodeId = 0;
    protected bool inheritsPermissions = false;
    protected AclProvider aclProv = null;
    protected TreeProvider tree = null;
    protected DataSet dsAclItems = null;

    protected void Page_Load(System.Object sender, System.EventArgs e)
    {
        if (DataHelper.GetNotEmpty(UrlHelper.GetCurrentDomain(), "") != "")
        {
            if (!LicenseKeyInfoProvider.IsFeatureAvailable(UrlHelper.GetCurrentDomain(), FeatureEnum.DocumentLevelPermissions))
            {
                pnlPermissions.Visible = false;
                lblLicenseInfo.Visible = true;
                lblLicenseInfo.Text = ResHelper.GetString("Security.NotAvailableInThisEdition");
            }
        }


        // Register dialog script
        this.Page.ClientScript.RegisterClientScriptBlock(typeof(string), ScriptHelper.DIALOG_SCRIPT_KEY, ScriptHelper.DialogScript);

        lblInfo.Text = "";

        if ((Request.QueryString["nodeid"] != null) && (Request.QueryString["nodeid"] != ""))
        {
            nodeId = Convert.ToInt32(Request.QueryString["nodeid"]);
        }

        

        tree = new TreeProvider(CMSContext.CurrentUser);
        
        aclProv = new AclProvider(tree);

        //if ((!Page.IsPostBack) && ((Request.QueryString["returnback"] != null) && (Request.QueryString["returnback"] != "")))
        //{
        //    ViewState["returnback"] = Request.UrlReferrer.ToString();
        //}

        // set labels
        if (!(Page.IsPostBack))
        {

            pnlPermissionsPart.GroupingText = ResHelper.GetString("Security.Permissions");
            pnlAccessPart.GroupingText = ResHelper.GetString("Security.Access");
                      
            lblReqAuthent.Text = ResHelper.GetString("Security.RadioCaption");
            radYes.Text = ResHelper.GetString("Security.Yes");
            radNo.Text = ResHelper.GetString("Security.No");
            radParent.Text = ResHelper.GetString("Security.Parent");
            radParent.Checked = true;

            lblAccessRights.Text = ResHelper.GetString("Security.AccessRights");
            lblUsersRoles.Text = ResHelper.GetString("Security.UsersRoles");            
            lblAllow.Text = ResHelper.GetString("Security.Allow");
            lblDeny.Text = ResHelper.GetString("Security.Deny");
            lblFullControl.Text = ResHelper.GetString("Security.FullControl");
            lblRead.Text = ResHelper.GetString("Security.Read");
            lblModify.Text = ResHelper.GetString("Security.Modify");
            lblCreate.Text = ResHelper.GetString("Security.Create");
            lblDelete.Text = ResHelper.GetString("Security.Delete");
            lblDestroy.Text = ResHelper.GetString("Security.Destroy");
            lblExploreTree.Text = ResHelper.GetString("Security.ExploreTree");
            lblManagePermissions.Text = ResHelper.GetString("Security.ManagePermissions");
            btnOK.Text = ResHelper.GetString("Security.OK");
            btnRadOk.Text = ResHelper.GetString("Security.OK");
            btnAddOperator.Text = ResHelper.GetString("Security.AddOperator");
            btnRemoveOperator.Text = ResHelper.GetString("Security.RemoveOperator");
            lnkBreakWithClear.Text = ResHelper.GetString("Security.BreakWithClear");
            lnkBreakWithCopy.Text = ResHelper.GetString("Security.BreakWithCopy");
            lnkRestoreInheritance.Text = ResHelper.GetString("Security.RestoreInheritance");
            btnCancel.Text = ResHelper.GetString("Security.Cancel");
            lnkInheritance.Text = ResHelper.GetString("Security.Inheritance");
        }

        // gets node
        if (nodeId != 0)
        {
            node = tree.SelectSingleNode(nodeId, TreeProvider.ALL_CULTURES);
        }
        else
        {
            pnlTab.Visible = false;
            return;
        }
        /*
        // checks permissions
        if (!CMSContext.CurrentUser.IsAuthorizedPerResource("cms.content", "ModifyPermissions") && (CMSContext.CurrentUser.IsAuthorizedPerTreeNode(nodeId, NodePermissionsEnum.ModifyPermissions)!=AuthorizationResultEnum.Allowed))
        {
            RedirectToAccessDenied(nodeId, "Modify permissions (security.aspx)");
            return;
        }
        */

        // Check read permissions
        if (CMSContext.CurrentUser.IsAuthorizedPerTreeNode(nodeId, NodePermissionsEnum.Read) == AuthorizationResultEnum.Denied)
        {
            CMSDeskPage.RedirectToAccessDenied(String.Format(ResHelper.GetString("cmsdesk.notauthorizedtoreaddocument"), node.NodeAliasPath));
        }
        // Check modify permissions
        else if (CMSContext.CurrentUser.IsAuthorizedPerTreeNode(nodeId, NodePermissionsEnum.ModifyPermissions) == AuthorizationResultEnum.Denied)
        {            
            pnlPermissionsPart.Enabled = false;
            pnlAccessPart.Enabled = false;
            lblSecurityInfo.Visible = true;
            lblSecurityInfo.Text = String.Format(ResHelper.GetString("cmsdesk.notauthorizedtoeditdocument"), node.NodeAliasPath);
        }
        else
        {
            lblSecurityInfo.Visible = false;
        }

        if (!(Page.IsPostBack))
        {
            // loads operators
            LoadOperators();
        }

        // check if document inherits permissions and display info
        inheritsPermissions = aclProv.DoesNodeInheritPermissions(nodeId);
        if (inheritsPermissions)
        {
            lblInheritanceInfo.Text = ResHelper.GetString("Security.InheritsInfo.Inherits");
        }
        else
        {
            lblInheritanceInfo.Text = ResHelper.GetString("Security.InheritsInfo.DoesNotInherit");
        }

        if (!Page.IsPostBack)
        {
            // Set secured radio buttons
            switch (node.IsSecuredNode)
            {
                case 0: radNo.Checked = true; radYes.Checked = false; radParent.Checked = false; break;
                case 1: radNo.Checked = false; radYes.Checked = true; radParent.Checked = false; break;
                default: radNo.Checked = false; radYes.Checked = false; radParent.Checked = true; break;
            }
        }


        // adds additional events to controls
        btnAddOperator.Attributes.Add("onclick", "AddOperator('" + nodeId + "'); return false;");
        chkFullControlAllow.Attributes.Add("onclick", "CheckAllAllowCheckBoxes();");
        chkFullControlDeny.Attributes.Add("onclick", "CheckAllDenyCheckBoxes();");
        chkCreateAllow.Attributes.Add("onclick", "CheckFullCheck('allow');");
        chkCreateDeny.Attributes.Add("onclick", "CheckFullCheck('deny');");
        chkDeleteAllow.Attributes.Add("onclick", "CheckFullCheck('allow');");
        chkDeleteDeny.Attributes.Add("onclick", "CheckFullCheck('deny');");
        chkDestroyAllow.Attributes.Add("onclick", "CheckFullCheck('allow');");
        chkDestroyDeny.Attributes.Add("onclick", "CheckFullCheck('deny');");
        chkExploreTreeAllow.Attributes.Add("onclick", "CheckFullCheck('allow');");
        chkExploreTreeDeny.Attributes.Add("onclick", "CheckFullCheck('deny');");
        chkManagePermissionsAllow.Attributes.Add("onclick", "CheckFullCheck('allow');");
        chkManagePermissionsDeny.Attributes.Add("onclick", "CheckFullCheck('deny');");
        chkModifyAllow.Attributes.Add("onclick", "CheckFullCheck('allow');");
        chkModifyDeny.Attributes.Add("onclick", "CheckFullCheck('deny');");
        chkReadAllow.Attributes.Add("onclick", "CheckFullCheck('allow');");
        chkReadDeny.Attributes.Add("onclick", "CheckFullCheck('deny');");

        this.ltlScript.Text = ScriptHelper.GetScript("function UpdateForm(){ " + ClientScript.GetPostBackEventReference(btnUpdate, "") + "; } \n");

        // hide link to the inheritance settings if this is the parent node
        if (node.NodeParentID == 0)
        {
            lnkInheritance.Visible = false;
        }

        

        // if there is no item in listbox, disables checkboxes
        if (lstOperators.Items.Count == 0)
        {
            ResetPermissions();
            DisableAllCheckBoxes();
        }
    }



    // ''<summary>Loads users and roles listed in the ACL of the selected document and displays them in the listbox.</summary>
    private void LoadOperators()
    {
        DataSet dsAclItems = null;
        string lastOperator = "";

        lstOperators.Items.Clear();
        dsAclItems = GetACLItems();
        if ((dsAclItems != null) && (dsAclItems.Tables.Count > 0))
        {
            foreach (DataRow drAclItem in dsAclItems.Tables[0].Rows)
            {
                if (drAclItem["Operator"].ToString() != lastOperator)
                {
                    lastOperator = drAclItem["Operator"].ToString();
                    lstOperators.Items.Add(new ListItem(drAclItem["OperatorName"].ToString(), drAclItem["Operator"].ToString()));
                }
            }
        }
        if (lstOperators.Items.Count > 0)
        {
            lstOperators.SelectedIndex = 0;
            DisplayOperatorPermissions(lstOperators.SelectedValue);
        }
        else
        {
            ResetPermissions();
            DisableAllCheckBoxes();
        }
    }



    // ''<summary>Returns ACLItems for the selected document.</summary>
    private DataSet GetACLItems()
    {
        if (dsAclItems == null)
        {
            dsAclItems = aclProv.GetACLItems(nodeId);
        }
        return dsAclItems;
    }



    // ''<summary>Displays permissions of the selected operator (user or role).</summary>
    // ''<param name="operatorID">OperatorID in format U123 or R123 where U/R indicates user/role and 123 is UserID/RoleID value.</param>
    private void DisplayOperatorPermissions(string operatorID)
    {
        ResetPermissions();

        DataSet dsAclItems = GetACLItems();
        DataRow[] rows = null;
        int i = 0;
        int allowed = 0;
        int denied = 0;
        bool hasNativePermissions = false;
        bool hasInheritedPermissions = false;

        if ((dsAclItems != null) && (dsAclItems.Tables.Count > 0))
        {
            // process inherited permissions
            rows = dsAclItems.Tables[0].Select(" Operator = '" + operatorID + "' AND ACLOwnerNodeID <> '" + node.NodeID.ToString() + "' ");
            for (i = 0; i <= rows.GetUpperBound(0); i++)
            {
                hasInheritedPermissions = true;
                allowed = Convert.ToInt32(rows[i]["Allowed"]);
                denied = Convert.ToInt32(rows[i]["Denied"]);

                // set "allow" check boxes for inherited permissions
                chkReadAllow.Checked = chkReadAllow.Checked | IsPermissionTrue(allowed, NodePermissionsEnum.Read);
                chkReadAllow.Enabled = chkReadAllow.Enabled & !(IsPermissionTrue(allowed, NodePermissionsEnum.Read));
                chkModifyAllow.Checked = chkModifyAllow.Checked | IsPermissionTrue(allowed, NodePermissionsEnum.Modify);
                chkModifyAllow.Enabled = chkModifyAllow.Enabled & !(IsPermissionTrue(allowed, NodePermissionsEnum.Modify));
                chkCreateAllow.Checked = chkCreateAllow.Checked | IsPermissionTrue(allowed, NodePermissionsEnum.Create);
                chkCreateAllow.Enabled = chkCreateAllow.Enabled & !(IsPermissionTrue(allowed, NodePermissionsEnum.Create));
                chkDeleteAllow.Checked = chkDeleteAllow.Checked | IsPermissionTrue(allowed, NodePermissionsEnum.Delete);
                chkDeleteAllow.Enabled = chkDeleteAllow.Enabled & !(IsPermissionTrue(allowed, NodePermissionsEnum.Delete));
                chkDestroyAllow.Checked = chkDestroyAllow.Checked | IsPermissionTrue(allowed, NodePermissionsEnum.Destroy);
                chkDestroyAllow.Enabled = chkDestroyAllow.Enabled & !(IsPermissionTrue(allowed, NodePermissionsEnum.Destroy));
                chkExploreTreeAllow.Checked = chkExploreTreeAllow.Checked | IsPermissionTrue(allowed, NodePermissionsEnum.ExploreTree);
                chkExploreTreeAllow.Enabled = chkExploreTreeAllow.Enabled & !(IsPermissionTrue(allowed, NodePermissionsEnum.ExploreTree));
                chkManagePermissionsAllow.Checked = chkManagePermissionsAllow.Checked | IsPermissionTrue(allowed, NodePermissionsEnum.ModifyPermissions);
                chkManagePermissionsAllow.Enabled = chkManagePermissionsAllow.Enabled & !(IsPermissionTrue(allowed, NodePermissionsEnum.ModifyPermissions));
                // set "deny" checkboxes for inherited permissions
                chkReadDeny.Checked = chkReadDeny.Checked | IsPermissionTrue(denied, NodePermissionsEnum.Read);
                chkReadDeny.Enabled = chkReadDeny.Enabled & !(IsPermissionTrue(denied, NodePermissionsEnum.Read));
                chkModifyDeny.Checked = chkModifyDeny.Checked | IsPermissionTrue(denied, NodePermissionsEnum.Modify);
                chkModifyDeny.Enabled = chkModifyDeny.Enabled & !(IsPermissionTrue(denied, NodePermissionsEnum.Modify));
                chkCreateDeny.Checked = chkCreateDeny.Checked | IsPermissionTrue(denied, NodePermissionsEnum.Create);
                chkCreateDeny.Enabled = chkCreateDeny.Enabled & !(IsPermissionTrue(denied, NodePermissionsEnum.Create));
                chkDeleteDeny.Checked = chkDeleteDeny.Checked | IsPermissionTrue(denied, NodePermissionsEnum.Delete);
                chkDeleteDeny.Enabled = chkDeleteDeny.Enabled & !(IsPermissionTrue(denied, NodePermissionsEnum.Delete));
                chkDestroyDeny.Checked = chkDestroyDeny.Checked | IsPermissionTrue(denied, NodePermissionsEnum.Destroy);
                chkDestroyDeny.Enabled = chkDestroyDeny.Enabled & !(IsPermissionTrue(denied, NodePermissionsEnum.Destroy));
                chkExploreTreeDeny.Checked = chkExploreTreeDeny.Checked | IsPermissionTrue(denied, NodePermissionsEnum.ExploreTree);
                chkExploreTreeDeny.Enabled = chkExploreTreeDeny.Enabled & !(IsPermissionTrue(denied, NodePermissionsEnum.ExploreTree));
                chkManagePermissionsDeny.Checked = chkManagePermissionsDeny.Checked | IsPermissionTrue(denied, NodePermissionsEnum.ModifyPermissions);
                chkManagePermissionsDeny.Enabled = chkManagePermissionsDeny.Enabled & !(IsPermissionTrue(denied, NodePermissionsEnum.ModifyPermissions));
            }
            // process native permissions
            rows = dsAclItems.Tables[0].Select(" Operator = '" + operatorID + "' AND ACLOwnerNodeID = '" + node.NodeID.ToString() + "' ");
            for (i = 0; i <= rows.GetUpperBound(0); i++)
            {
                hasNativePermissions = true;
                allowed = Convert.ToInt32(rows[i]["Allowed"]);
                denied = Convert.ToInt32(rows[i]["Denied"]);

                // set "allow" check boxes for native permissions
                SetCheckBoxWithNativePermission(chkReadAllow, IsPermissionTrue(allowed, NodePermissionsEnum.Read));
                SetCheckBoxWithNativePermission(chkModifyAllow, IsPermissionTrue(allowed, NodePermissionsEnum.Modify));
                SetCheckBoxWithNativePermission(chkCreateAllow, IsPermissionTrue(allowed, NodePermissionsEnum.Create));
                SetCheckBoxWithNativePermission(chkDeleteAllow, IsPermissionTrue(allowed, NodePermissionsEnum.Delete));
                SetCheckBoxWithNativePermission(chkDestroyAllow, IsPermissionTrue(allowed, NodePermissionsEnum.Destroy));
                SetCheckBoxWithNativePermission(chkExploreTreeAllow, IsPermissionTrue(allowed, NodePermissionsEnum.ExploreTree));
                SetCheckBoxWithNativePermission(chkManagePermissionsAllow, IsPermissionTrue(allowed, NodePermissionsEnum.ModifyPermissions));

                // set "deny" checkboxes for inherited permissions
                SetCheckBoxWithNativePermission(chkReadDeny, IsPermissionTrue(denied, NodePermissionsEnum.Read));
                SetCheckBoxWithNativePermission(chkModifyDeny, IsPermissionTrue(denied, NodePermissionsEnum.Modify));
                SetCheckBoxWithNativePermission(chkCreateDeny, IsPermissionTrue(denied, NodePermissionsEnum.Create));
                SetCheckBoxWithNativePermission(chkDeleteDeny, IsPermissionTrue(denied, NodePermissionsEnum.Delete));
                SetCheckBoxWithNativePermission(chkDestroyDeny, IsPermissionTrue(denied, NodePermissionsEnum.Destroy));
                SetCheckBoxWithNativePermission(chkExploreTreeDeny, IsPermissionTrue(denied, NodePermissionsEnum.ExploreTree));
                SetCheckBoxWithNativePermission(chkManagePermissionsDeny, IsPermissionTrue(denied, NodePermissionsEnum.ModifyPermissions));
            }
        }

        this.btnRemoveOperator.Enabled = (!(hasInheritedPermissions)) && hasNativePermissions;
        CheckFullControlBox();
    }



    // ''<summary>Parses permission value and return true if appropriate bit is 1.</summary>
    protected bool IsPermissionTrue(int permissionValue, NodePermissionsEnum permission)
    {
        return ((permissionValue >> Convert.ToInt32(permission)) % 2) == 1;
    }



    // ''<summary>Checks checkbox if provided value is true.</summary>
    protected void SetCheckBoxWithNativePermission(CheckBox chkBox, bool value)
    {
        if (value == true)
        {
            chkBox.Checked = value;
        }
    }



    // ''<summary>Returns integer value representing permission value of the given checkbox and permission name.</summary>
    protected int GetCheckBoxValue(CheckBox chkBox, NodePermissionsEnum permission)
    {
        if (chkBox.Enabled && chkBox.Checked)
        {
            return Convert.ToInt32(Math.Pow(2, Convert.ToInt32(permission)));
        }
        else
        {
            return 0;
        }
    }



    protected void lstOperators_SelectedIndexChanged(Object sender, EventArgs e)
    {
        if (lstOperators.SelectedItem != null)
        {
            DisplayOperatorPermissions(lstOperators.SelectedValue);
        }
        else
            DisableAllCheckBoxes();
    }


    // ''<summary>Saves data.</summary>
    protected void btnOK_Click(Object sender, EventArgs e)
    {
        int allowed = 0;
        int denied = 0;
        string operatorID = null;

        if (lstOperators.SelectedItem == null)
        {
            return;
        }
        else
        {
            operatorID = lstOperators.SelectedValue;
            allowed += GetCheckBoxValue(chkReadAllow, NodePermissionsEnum.Read);
            allowed += GetCheckBoxValue(chkModifyAllow, NodePermissionsEnum.Modify);
            allowed += GetCheckBoxValue(chkCreateAllow, NodePermissionsEnum.Create);
            allowed += GetCheckBoxValue(chkDeleteAllow, NodePermissionsEnum.Delete);
            allowed += GetCheckBoxValue(chkDestroyAllow, NodePermissionsEnum.Destroy);
            allowed += GetCheckBoxValue(chkExploreTreeAllow, NodePermissionsEnum.ExploreTree);
            allowed += GetCheckBoxValue(chkManagePermissionsAllow, NodePermissionsEnum.ModifyPermissions);
            denied += GetCheckBoxValue(chkReadDeny, NodePermissionsEnum.Read);
            denied += GetCheckBoxValue(chkModifyDeny, NodePermissionsEnum.Modify);
            denied += GetCheckBoxValue(chkCreateDeny, NodePermissionsEnum.Create);
            denied += GetCheckBoxValue(chkDeleteDeny, NodePermissionsEnum.Delete);
            denied += GetCheckBoxValue(chkDestroyDeny, NodePermissionsEnum.Destroy);
            denied += GetCheckBoxValue(chkExploreTreeDeny, NodePermissionsEnum.ExploreTree);
            denied += GetCheckBoxValue(chkManagePermissionsDeny, NodePermissionsEnum.ModifyPermissions);

            if (operatorID.StartsWith("U"))
            {
                int userId = int.Parse(operatorID.Substring(1));
                UserInfo ui = UserInfoProvider.GetUserInfo(userId);
                aclProv.SetUserPermissions(node, allowed, denied, ui);
            }
            else
            {
                aclProv.SetRolePermissions(node, allowed, denied, int.Parse(operatorID.Substring(1)));
            }
            this.lblInfo.Text = ResHelper.GetString("Security.ChangesSaved");
            
            // EventLog provider.
            EventLogProvider ev = new EventLogProvider(tree.Connection);
            // Insert information about this event to eventlog.
            ev.LogEvent("I", DateTime.Now, "Content", "DOCPERMISSIONSMODIFIED", tree.UserInfo.UserID, tree.UserInfo.UserName, nodeId, node.DocumentName, HttpContext.Current.Request.UserHostAddress, "Permissions of the document have been modified.", node.NodeSiteID, HttpContext.Current.Request.Url.AbsoluteUri);
        }
    }


    protected void btnUpdate_Click(Object sender, EventArgs e)
    {
        LoadOperators();
    }


    // ''<summary>Removes selected operator from the ACL.</summary>
    protected void btnRemoveOperator_Click(Object sender, EventArgs e)
    {
        if (lstOperators.SelectedItem == null)
        {
            return;
        }

        string operatorID = lstOperators.SelectedValue;
        if (operatorID.StartsWith("U"))
        {
            int userId = int.Parse(operatorID.Substring(1));
            UserInfo ui = UserInfoProvider.GetUserInfo(userId);
            aclProv.RemoveUser(nodeId, ui);
        }
        else
        {
            aclProv.RemoveRole(nodeId, int.Parse(operatorID.Substring(1)));
        }
        LoadOperators();
    }



    // ''<summary>Resets all checkboxes representing permissions.</summary>
    protected void ResetPermissions()
    {
        ResetCheckBox(chkFullControlAllow);
        ResetCheckBox(chkFullControlDeny);
        ResetCheckBox(chkReadAllow);
        ResetCheckBox(chkReadDeny);
        ResetCheckBox(chkCreateAllow);
        ResetCheckBox(chkCreateDeny);
        ResetCheckBox(chkModifyAllow);
        ResetCheckBox(chkModifyDeny);
        ResetCheckBox(chkDeleteAllow);
        ResetCheckBox(chkDeleteDeny);
        ResetCheckBox(chkDestroyAllow);
        ResetCheckBox(chkDestroyDeny);
        ResetCheckBox(chkExploreTreeAllow);
        ResetCheckBox(chkExploreTreeDeny);
        ResetCheckBox(chkManagePermissionsAllow);
        ResetCheckBox(chkManagePermissionsDeny);
    }



    // ''<summary>Resets given checkbox.</summary>
    protected void ResetCheckBox(CheckBox chkBox)
    {
        chkBox.Enabled = true;
        chkBox.Checked = false;
    }



    // ''<summary>Displays inheritance settings.</summary>
    protected void lnkInheritance_Click(Object sender, EventArgs e)
    {
        pnlPermissionsPart.Visible = false;
        pnlAccessPart.Visible = false;
        pnlInheritance.Visible = true;

        // test if current document inherits permissions
        if (inheritsPermissions)
        {
            lnkBreakWithClear.Visible = true;
            lnkBreakWithCopy.Visible = true;
            lnkRestoreInheritance.Visible = false;
        }
        else
        {
            lnkBreakWithClear.Visible = false;
            lnkBreakWithCopy.Visible = false;
            lnkRestoreInheritance.Visible = true;
        }
    }



    protected void btnCancel_Click(Object sender, EventArgs e)
    {
        SwitchBackToPermissionsMode();
    }



    private void SwitchBackToPermissionsMode()
    {
        pnlPermissionsPart.Visible = true;
        pnlAccessPart.Visible = true;
        pnlInheritance.Visible = false;
    }



    protected void lnkBreakWithCopy_Click(Object sender, EventArgs e)
    {
        // break permission inheritance and copy parent permissions
        aclProv.BreakInherintance(node, true);
        lblInheritanceInfo.Text = ResHelper.GetString("Security.InheritsInfo.DoesNotInherit");
        SwitchBackToPermissionsMode();
        LoadOperators();
    }



    protected void lnkBreakWithClear_Click(Object sender, EventArgs e)
    {
        // break permission inheritance and clear permissions
        aclProv.BreakInherintance(node, false);
        lblInheritanceInfo.Text = ResHelper.GetString("Security.InheritsInfo.DoesNotInherit");
        SwitchBackToPermissionsMode();
        LoadOperators();
    }



    protected void lnkRestoreInheritance_Click(Object sender, EventArgs e)
    {
        // restore inheritance and add permissions inherited from the parent document
        aclProv.RestoreInheritance(node);
        lblInheritanceInfo.Text = ResHelper.GetString("Security.InheritsInfo.Inherits");
        SwitchBackToPermissionsMode();
        LoadOperators();
    }


    protected void chkFullControlAllow_CheckedChanged(Object sender, EventArgs e)
    {
        // check all enabled checkboxes
        CheckEnabledCheckbox(chkReadAllow, chkFullControlAllow.Checked);
        CheckEnabledCheckbox(chkCreateAllow, chkFullControlAllow.Checked);
        CheckEnabledCheckbox(chkModifyAllow, chkFullControlAllow.Checked);
        CheckEnabledCheckbox(chkDeleteAllow, chkFullControlAllow.Checked);
        CheckEnabledCheckbox(chkDestroyAllow, chkFullControlAllow.Checked);
        CheckEnabledCheckbox(chkExploreTreeAllow, chkFullControlAllow.Checked);
        CheckEnabledCheckbox(chkManagePermissionsAllow, chkFullControlAllow.Checked);
    }


    protected void CheckEnabledCheckbox(CheckBox chkBox, bool checkedIdent)
    {
        if (chkBox.Enabled)
        {
            chkBox.Checked = checkedIdent;
        }
    }


    protected void chkFullControlDeny_CheckedChanged(Object sender, EventArgs e)
    {
        // check all deny checkboxes
        CheckEnabledCheckbox(chkReadDeny, chkFullControlDeny.Checked);
        CheckEnabledCheckbox(chkCreateDeny, chkFullControlDeny.Checked);
        CheckEnabledCheckbox(chkModifyDeny, chkFullControlDeny.Checked);
        CheckEnabledCheckbox(chkDeleteDeny, chkFullControlDeny.Checked);
        CheckEnabledCheckbox(chkDestroyDeny, chkFullControlDeny.Checked);
        CheckEnabledCheckbox(chkExploreTreeDeny, chkFullControlDeny.Checked);
        CheckEnabledCheckbox(chkManagePermissionsDeny, chkFullControlDeny.Checked);
    }


    private void CheckFullControlBox()
    {
        chkFullControlAllow.Checked = chkReadAllow.Checked && chkModifyAllow.Checked && chkCreateAllow.Checked && chkDeleteAllow.Checked && chkDestroyAllow.Checked && chkExploreTreeAllow.Checked && chkManagePermissionsAllow.Checked;
        chkFullControlDeny.Checked = chkReadDeny.Checked && chkModifyDeny.Checked && chkCreateDeny.Checked && chkDeleteDeny.Checked && chkDestroyDeny.Checked && chkExploreTreeDeny.Checked && chkManagePermissionsDeny.Checked;
    }

    protected void DisableAllCheckBoxes()
    {
        chkCreateAllow.Enabled = false;
        chkCreateDeny.Enabled = false;
        chkDeleteAllow.Enabled = false;
        chkDeleteDeny.Enabled = false;
        chkDestroyAllow.Enabled = false;
        chkDestroyDeny.Enabled = false;
        chkExploreTreeAllow.Enabled = false;
        chkExploreTreeDeny.Enabled = false;
        chkFullControlAllow.Enabled = false;
        chkFullControlDeny.Enabled = false;
        chkManagePermissionsAllow.Enabled = false;
        chkManagePermissionsDeny.Enabled = false;
        chkModifyAllow.Enabled = false;
        chkModifyDeny.Enabled = false;
        chkReadAllow.Enabled = false;
        chkReadDeny.Enabled = false;
    }
    
    /// <summary>
    /// On click OK save secured settings
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void radioButton_CheckedChanged(object sender, EventArgs e)
    {
        if (radYes.Checked)
        {
            node.IsSecuredNode = 1;
            //node.SetValue("IsSecuredNode", 1);
        }

        if (radNo.Checked)
        {
            node.IsSecuredNode = 0;
            //node.SetValue("IsSecuredNode", 0);
        }

        if (radParent.Checked)
        {
            node.IsSecuredNode = -1;
           // node.SetValue("IsSecuredNode", null);
        }

        node.Update();

        lblAccessInfo.Visible = true;
        lblAccessInfo.Text = ResHelper.GetString("Security.ChangesSaved");
        
        
    }
}
