using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.SiteProvider;
using CMS.CMSHelper;

public partial class CMSDesk_Content_SelectImageDialog_Header : CMSDeskPage
{
    protected void Page_Load(object sender, EventArgs e)
    {

        string select = ValidationHelper.GetString(Request.QueryString["select"], "image");
        if (select.ToLower() == "image")
        {
            titleElem.TitleText = ResHelper.GetString("SelectImageDialog.Title");
            titleElem.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/Content/SelectImageDialog/selectimage.gif";
        }
        else
        {
            titleElem.TitleText = ResHelper.GetString("SelectFlashDialog.Title");
            titleElem.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/Content/SelectImageDialog/selectflash.gif";
        }

        lblSite.Text = ResHelper.GetString("SelectImageDialog.Site");

                
        // Fill in the site list
        if (drpSites.Items.Count == 0)
        {

            // If actual user is global administrator, get all sites
            if (CMSContext.CurrentUser.IsGlobalAdministrator)
            {
                DataSet ds = SiteInfoProvider.GetAllSites();
                if (!DataHelper.DataSourceIsEmpty(ds))
                {
                    drpSites.DataSource = ds.Tables[0];
                    drpSites.DataBind();
                }
            }
            // Else get only user's sites.
            else
            {
                DataTable ds = UserInfoProvider.GetUserSites(CMSContext.CurrentUser.UserID);

                if (!DataHelper.DataSourceIsEmpty(ds))
                {
                    drpSites.DataSource = ds;
                    drpSites.DataBind();
                }
            }
            
            try
            {
                drpSites.SelectedValue = CMSContext.CurrentSite.SiteID.ToString();
            }
            catch
            {
            }
        }

        // Set tree URL
        string treeUrl = "tree.aspx" + Request.Url.Query;
        if (treeUrl.IndexOf("?") >= 0)
        {
            treeUrl += "&siteid=";
        }
        else
        {
            treeUrl += "?siteid=";
        }
        this.ltlScript.Text += ScriptHelper.GetScript("var treeUrl='" + treeUrl + "';");

        drpSites.Attributes.Add("onchange", "RefreshSite(this);");
    }

}
