using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.TreeEngine;
using CMS.CMSSiteMapProvider;
using CMS.GlobalHelper;

public partial class CMSDesk_Content_tree : CMSDeskPage
{
    protected void Page_Load(object sender, EventArgs e)
    {
        this.ltlScript.Text = ScriptHelper.GetScript("treeUrl = '" + ResolveUrl("~/CMSDesk/Content/Tree.aspx") + "';");

        this.treeContent.NodeTextTemplate = "<span class=\"ContentTreeItem\" onclick=\"SelectNode(##NODEID##, this); return false;\">##NODENAME##</span>";
        this.treeContent.SelectedNodeTextTemplate = "<span id=\"treeSelectedNode\" class=\"ContentTreeSelectedItem\" onclick=\"SelectNode(##NODEID##, this); return false;\">##NODENAME##</span>";

        // If nodeId set, init the list of the nodes to expand
        int expandNodeId = 0;
        if (Request.QueryString["expandnodeid"] != null)
        {
            expandNodeId = ValidationHelper.GetInteger(Request.QueryString["expandnodeid"], 0);
        }
        this.treeContent.ExpandNodeID = expandNodeId;

        // Current Node ID
        int nodeId = 0;
        if (Request.QueryString["nodeid"] != null)
        {
            nodeId = ValidationHelper.GetInteger(Request.QueryString["nodeid"], 0);
        }
        this.treeContent.NodeID = nodeId;

        // Setup the current node script
        if (nodeId > 0)
        {
            this.ltlScript.Text += ScriptHelper.GetScript("    currentNodeId = " + nodeId + ";");
        }
    }
}
