using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.Newsletter;
using CMS.GlobalHelper;
using CMS.Scheduler;
using CMS.CMSHelper;

public partial class CMSDesk_Tools_Newsletters_Newsletters_Newsletter_Configuration : CMSDeskPage
{
    protected int newsletterId = 0;
    protected bool isDynamic = false;
    
    protected void Page_Load(object sender, EventArgs e)
    {

        newsletterId = ValidationHelper.GetInteger(Request.QueryString["newsletterid"], 0);

        if (newsletterId == 0)
        {
            return;
        }
        
        rfvNewsletterDisplayName.ErrorMessage = ResHelper.GetString("Newsletter_Edit.ErrorEmptyDisplayName");
        rfvNewsletterName.ErrorMessage = ResHelper.GetString("Newsletter_Edit.ErrorEmptyName");
        rfvNewsletterSenderName.ErrorMessage = ResHelper.GetString("Newsletter_Edit.ErrorEmptySenderName");
        rfvNewsletterSenderEmail.ErrorMessage = ResHelper.GetString("Newsletter_Edit.ErrorEmptySenderEmail");


        //lblNewsletterDynamicScheduledTaskID.Text = ResHelper.GetString("Newsletter_Edit.NewsletterDynamicScheduledTaskIDLabel");
        lblNewsletterName.Text = ResHelper.GetString("Newsletter_Edit.NewsletterNameLabel");
        lblNewsletterDisplayName.Text = ResHelper.GetString("Newsletter_Edit.NewsletterDisplayNameLabel");
        lblNewsletterSenderName.Text = ResHelper.GetString("Newsletter_Edit.NewsletterSenderNameLabel");
        lblNewsletterDynamicURL.Text = ResHelper.GetString("Newsletter_Edit.NewsletterDynamicURLLabel");
        lblNewsletterSenderEmail.Text = ResHelper.GetString("Newsletter_Edit.NewsletterSenderEmailLabel");
        lblSubscriptionTemplate.Text = ResHelper.GetString("Newsletter_Edit.SubscriptionTemplate");
        lblUnsubscriptionTemplate.Text = ResHelper.GetString("Newsletter_Edit.UnsubscriptionTemplate");
        lblIssueTemplate.Text = ResHelper.GetString("Newsletter_Edit.NewsletterTemplate");
        lblDynamic.Text = ResHelper.GetString("Newsletter_Configuration.Dynamic");
        lblTemplateBased.Text = ResHelper.GetString("Newsletter_Configuration.TemplateBased");
        lblNewsletterDynamicURL.Text = ResHelper.GetString("Newsletter_Edit.SourcePageURL");
        lblSchedule.Text = ResHelper.GetString("Newsletter_Edit.Schedule");
        lblSubject.Text = ResHelper.GetString("Newsletter_Configuration.Subject");
        lblPageTitle.Text = ResHelper.GetString("Newsletter_Configuration.PageTitleSubject");
        lblFollowing.Text = ResHelper.GetString("Newsletter_Configuration.PageTitleFollowing");
        lblNewsletterUnsubscribeUrl.Text = ResHelper.GetString("Newsletter_Configuration.NewsletterUnsubscribeUrl");
        btnOK.Text = ResHelper.GetString("General.OK");

        if (!IsPostBack)
        {
            Newsletter news = NewsletterProvider.GetNewsletter(newsletterId);
            if (news != null)
            {
                int siteId = news.NewsletterSiteID;
                LoadDrpSubscription(siteId);
                LoadDrpUnsubscription(siteId);
                LoadDrpIssueTemplates(siteId);
            }


            if (ValidationHelper.GetInteger(Request.QueryString["saved"], 0) > 0)
            {
                //if user was redirected from newsletter_new.aspx, display the 'Changes were saved' message
                {
                    lblInfo.Visible = true;
                    lblInfo.Text = ResHelper.GetString("General.ChangesSaved");
                }
            }
        }
        LoadData();

    }

    protected void LoadData()
    {
        Newsletter newsletterObj = NewsletterProvider.GetNewsletter(newsletterId);
        if (newsletterObj != null)
        {
            if (newsletterObj.NewsletterType == "D")
            {
                isDynamic = true;
                lblTemplateBased.Visible = false;
                lblDynamic.Visible = true;
                pnlDynamic.Visible = true;
                lblNewsletterDynamicURL.Visible = true;
                txtNewsletterDynamicURL.Visible = true;
                chkSchedule.Visible = true;
                lblSchedule.Visible = true;

                lblIssueTemplate.Visible = false;
                drpIssueTemplate.Visible = false;
            }
            else
            {
                isDynamic = false;
                lblTemplateBased.Visible = true;
                lblDynamic.Visible = false;
                pnlDynamic.Visible = false;
                lblNewsletterDynamicURL.Visible = false;
                txtNewsletterDynamicURL.Visible = false;
                chkSchedule.Visible = false;
                lblSchedule.Visible = false;

                lblIssueTemplate.Visible = true;
                drpIssueTemplate.Visible = true;
            }

           /* if (isDynamic)
            {
                newsletterObj.NewsletterDynamicURL = txtNewsletterDynamicURL.Text.Trim();
                if (radFollowing.Checked)
                {
                    newsletterObj.NewsletterDynamicSubject = txtSubject.Text;
                }
                else
                {
                    //newsletterObj.NewsletterDynamicSubject = page title;
                }
            }
            else
            {
                if (drpIssueTemplate.SelectedIndex > -1)
                {
                    newsletterObj.NewsletterTemplateID = Convert.ToInt32(drpIssueTemplate.SelectedValue);
                }
                newsletterObj.NewsletterType = "T";
            }*/

            if (!IsPostBack)
            {
                if (newsletterObj.NewsletterType == "D")
                {
                    ScheduleInterval1.Visible = true;
                }
                else
                {
                    ScheduleInterval1.Visible = false;
                }
                txtNewsletterDisplayName.Text = newsletterObj.NewsletterDisplayName;
                txtNewsletterName.Text = newsletterObj.NewsletterName;
                txtNewsletterSenderName.Text = newsletterObj.NewsletterSenderName;
                txtNewsletterSenderEmail.Text = newsletterObj.NewsletterSenderEmail;
                txtNewsletterUnsubscribeUrl.Text = newsletterObj.NewsletterUnsubscribeUrl;
                drpSubscriptionTemplate.SelectedValue = newsletterObj.NewsletterSubscriptionTemplateID.ToString();
                drpUnsubscriptionTemplate.SelectedValue = newsletterObj.NewsletterUnsubscriptionTemplateID.ToString();
                if (isDynamic)
                {
                    if ((newsletterObj.NewsletterDynamicSubject == null) || (newsletterObj.NewsletterDynamicSubject == ""))
                    {
                        radPageTitle.Checked = true;
                        radFollowing.Checked = false;
                        radPageTitle_CheckedChanged(null, null);
                    }
                    else
                    {
                        radPageTitle.Checked = false;
                        radFollowing.Checked = true;
                        radPageTitle_CheckedChanged(null, null);
                        txtSubject.Text = newsletterObj.NewsletterDynamicSubject;
                    }
                    txtNewsletterDynamicURL.Text = newsletterObj.NewsletterDynamicURL;
                    TaskInfo task = TaskInfoProvider.GetTaskInfo(newsletterObj.NewsletterDynamicScheduledTaskID);
                    if (task != null)
                    {
                        chkSchedule.Checked = true;
                        ScheduleInterval1.Visible = true;
                        ScheduleInterval1.ScheduleInterval = task.TaskInterval;
                    }
                    else
                    {
                        chkSchedule.Checked = false;
                        ScheduleInterval1.Visible = false;
                    }
                }
                else
                {
                    drpIssueTemplate.SelectedValue = newsletterObj.NewsletterTemplateID.ToString();
                }
            }
            else
            {
                if (chkSchedule.Checked)
                {
                    ScheduleInterval1.Visible = true;
                }
                else
                {
                    ScheduleInterval1.Visible = false;
                }
            }
        }
    }

    /// <summary>
    /// Sets data to database.
    /// </summary>
    protected void btnOK_Click(object sender, EventArgs e)
    {
        if (!CMSContext.CurrentUser.IsAuthorizedPerResource("cms.newsletter", "configure"))
        {
            CMSDeskPage.RedirectToAccessDenied("cms.newsletter", "configure");
        }
        string errorMessage = new Validator().NotEmpty(txtNewsletterDisplayName.Text, ResHelper.GetString("Newsletter_Edit.ErrorEmptyDisplayName")).NotEmpty(txtNewsletterName.Text, ResHelper.GetString("Newsletter_Edit.ErrorEmptyName")).NotEmpty(txtNewsletterSenderName.Text, ResHelper.GetString("Newsletter_Edit.ErrorEmptySenderName")).NotEmpty(txtNewsletterSenderEmail.Text, ResHelper.GetString("Newsletter_Edit.ErrorEmptySenderEmail")).Result;

        if (errorMessage == "")
        {

            // newsletterName must to be unique
            Newsletter newsletterObj = NewsletterProvider.GetNewsletter(txtNewsletterName.Text.Trim(), CMSContext.CurrentSite.SiteID);

            // if newsletterName value is unique														
            if ((newsletterObj == null) || (newsletterObj.NewsletterID == newsletterId))
            {
                if (newsletterObj == null)
                {
                    newsletterObj = NewsletterProvider.GetNewsletter(newsletterId);
                }

                if (newsletterObj != null)
                {
                    newsletterObj.NewsletterDisplayName = txtNewsletterDisplayName.Text.Trim();
                    newsletterObj.NewsletterName = txtNewsletterName.Text.Trim();
                    newsletterObj.NewsletterSenderName = txtNewsletterSenderName.Text.Trim();
                    newsletterObj.NewsletterSenderEmail = txtNewsletterSenderEmail.Text.Trim();
                    newsletterObj.NewsletterUnsubscribeUrl = txtNewsletterUnsubscribeUrl.Text.Trim();
                    if (drpSubscriptionTemplate.SelectedIndex > -1)
                    {
                        newsletterObj.NewsletterSubscriptionTemplateID = Convert.ToInt32(drpSubscriptionTemplate.SelectedValue);
                    }
                    else
                    {
                        lblError.Visible = true;
                        lblError.Text = ResHelper.GetString("Newsletter_Edit.NoSubscriptionTemplateSelected");
                        return;
                    }
                    if (drpUnsubscriptionTemplate.SelectedIndex > -1)
                    {
                        newsletterObj.NewsletterUnsubscriptionTemplateID = Convert.ToInt32(drpUnsubscriptionTemplate.SelectedValue);
                    }
                    else
                    {
                        lblError.Visible = true;
                        lblError.Text = ResHelper.GetString("Newsletter_Edit.NoUnsubscriptionTemplateSelected");
                        return;
                    }
                    if (isDynamic)
                    {
                        newsletterObj.NewsletterDynamicURL = txtNewsletterDynamicURL.Text.Trim();
                        newsletterObj.NewsletterType = "D";
                        if (radFollowing.Checked)
                        {
                            newsletterObj.NewsletterDynamicSubject = txtSubject.Text;
                        }
                        else
                        {
                            newsletterObj.NewsletterDynamicSubject = "";
                        }
                        if (chkSchedule.Checked)
                        {
                            //set info for scheduled task
                            TaskInfo task = TaskInfoProvider.GetTaskInfo(Convert.ToInt32(newsletterObj.NewsletterDynamicScheduledTaskID));
                            if (task == null)
                            {
                                task = new TaskInfo();
                                task.TaskAssemblyName = "CMS.Newsletter";
                                task.TaskClass = "CMS.Newsletter.DynamicNewsletterSender";
                                task.TaskEnabled = true;
                                task.TaskLastResult = "";
                                task.TaskSiteID = CMSContext.CurrentSite.SiteID;
                                task.TaskData = newsletterObj.NewsletterID.ToString();
                            }
                            if ((ScheduleInterval1.ScheduleInterval == ";1/1/0001 12:00:00 AM"))
                            {
                                //if problem occured while setting schedule interval
                                return;
                            }
                            else
                            {
                                task.TaskInterval = ScheduleInterval1.ScheduleInterval;
                            }
                            task.TaskNextRunTime = SchedulingHelper.GetNextTime(task.TaskInterval, new DateTime());
                            task.TaskDisplayName = "Send dynamic newsletter: " + newsletterObj.NewsletterName;
                            task.TaskName = "DynamicNewsletter:" + newsletterObj.NewsletterName;
                            TaskInfoProvider.SetTaskInfo(task);
                            newsletterObj.NewsletterDynamicScheduledTaskID = task.TaskID;
                            //DynamicNewsletterSender dns = new DynamicNewsletterSender();
                            //dns.Execute(task);
                        }
                        else
                        {
                            if (newsletterObj.NewsletterDynamicScheduledTaskID > 0)
                            {
                                TaskInfoProvider.DeleteTaskInfo(newsletterObj.NewsletterDynamicScheduledTaskID);
                            }
                            newsletterObj.NewsletterDynamicScheduledTaskID = 0;
                            ScheduleInterval1.Visible = false;
                        }
                    }
                    else
                    {
                        if (drpIssueTemplate.SelectedIndex > -1)
                        {
                            newsletterObj.NewsletterTemplateID = Convert.ToInt32(drpIssueTemplate.SelectedValue);
                        }
                        else
                        {
                            lblError.Visible = true;
                            lblError.Text = ResHelper.GetString("Newsletter_Edit.NoEmailTemplateSelected");
                            return;
                        }
                        newsletterObj.NewsletterType = "T";
                    }

                    NewsletterProvider.SetNewsletter(newsletterObj);
                    
                    lblInfo.Visible = true;
                    lblInfo.Text = ResHelper.GetString("General.ChangesSaved");
                    //Response.Redirect("Newsletter_Edit.aspx?newsletterid=" + Convert.ToString(newsletterObj.NewsletterID) + "&saved=1");
                }
                else
                {

                }
            }
            else
            {
                lblError.Visible = true;
                lblError.Text = ResHelper.GetString("Newsletter_Edit.NewsletterNameExists");
            }

        }
        else
        {
            lblError.Visible = true;
            lblError.Text = errorMessage;
        }
    }

    protected void LoadDrpSubscription(int siteId)
    {
        drpSubscriptionTemplate.DataSource = EmailTemplateProvider.GetAllSubscriptionTemplates(siteId);
        drpSubscriptionTemplate.DataValueField = "TemplateID";
        drpSubscriptionTemplate.DataTextField = "TemplateDisplayName";
        drpSubscriptionTemplate.DataBind();
        if (drpSubscriptionTemplate.Items.Count > 0)
        {
            drpSubscriptionTemplate.SelectedIndex = 0;
        }
    }

    protected void LoadDrpUnsubscription(int siteId)
    {
        drpUnsubscriptionTemplate.DataSource = EmailTemplateProvider.GetAllUnsubscriptionTemplates(siteId);
        drpUnsubscriptionTemplate.DataValueField = "TemplateID";
        drpUnsubscriptionTemplate.DataTextField = "TemplateDisplayName";
        drpUnsubscriptionTemplate.DataBind();
        if (drpUnsubscriptionTemplate.Items.Count > 0)
        {
            drpUnsubscriptionTemplate.SelectedIndex = 0;
        }
    }

    protected void LoadDrpIssueTemplates(int siteId)
    {
        drpIssueTemplate.DataSource = EmailTemplateProvider.GetAllIssueTemplates(siteId);
        drpIssueTemplate.DataValueField = "TemplateID";
        drpIssueTemplate.DataTextField = "TemplateDisplayName";
        drpIssueTemplate.DataBind();
        if (drpIssueTemplate.Items.Count > 0)
        {
            drpIssueTemplate.SelectedIndex = 0;
        }
    }

    protected void radPageTitle_CheckedChanged(object sender, EventArgs e)
    {
        if (radFollowing.Checked)
        {
            txtSubject.Enabled = true;
        }
        else
        {
            txtSubject.Enabled = false;
        }
    }

    protected void radFollowing_CheckedChanged(object sender, EventArgs e)
    {
        if (radFollowing.Checked)
        {
            txtSubject.Enabled = true;
        }
        else
        {
            txtSubject.Enabled = false;
        }
    }

    protected void chkSchedule_CheckedChanged(object sender, EventArgs e)
    {
        if (chkSchedule.Checked)
        {
            ScheduleInterval1.Visible = true;
        }
        else
        {
            ScheduleInterval1.Visible = false;
        }
    }
}
