using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Xml;
using System.IO;

using CMS.GlobalHelper;
using CMS.CMSHelper;
using CMS.FormEngine;

public partial class CMSFormControls_ColumnSelector : CMS.FormEngine.FormEngineUserControl
{

    protected override void OnPreRender(EventArgs e)
    {
        base.OnPreRender(e);

        bool IsQuery = true;
        bool IsClassNames = true;
        string mJavaScript = "";

        this.Page.ClientScript.RegisterClientScriptBlock(typeof(string), ScriptHelper.DIALOG_SCRIPT_KEY, ScriptHelper.DialogScript);

        btnDesign.OnClientClick = "OpenModalDialog('" + hdnSelectedColumns.ClientID.ToString() + "','" + txtColumns.ClientID.ToString() + "'); return false;";

        mJavaScript += "function SetValue(input, txtInput,hdnSelColId,hdnColId){document.getElementById(hdnSelColId).value = input; document.getElementById(hdnColId).value = txtInput;return false }\n";
        mJavaScript += "function GetClassNames(hdnColId)  { return document.getElementById(hdnColId).value; return false;    }\n";
        mJavaScript += "function GetSelectedColumns(hdnSelColId) { return document.getElementById(hdnSelColId).value; return false;   }\n";

        // Try to find QueryName or ClassNames field
        try
        {
            hdnProperties.Value = this.DataDR["QueryName"].ToString();
        }
        catch
        {
            IsQuery = false;
        }

        try
        {
            hdnProperties.Value = this.DataDR["ClassNames"].ToString();
        }
        catch
        {
            IsClassNames = false;
        }

        // if QueryName field was found
        if (IsQuery)
        {
            // if query name isnt empty
            if (hdnProperties.Value != null && hdnProperties.Value != "")
            {
                mJavaScript += "function OpenModalDialog(hdnSelColId, hdnColId) { modalDialog('" + ResolveUrl("~/CMSWebParts/Designers/GridColumnDesigner.aspx") + "?queryname=" + hdnProperties.Value + "&SelColId='+hdnSelColId+'&ColId='+hdnColId ,'GridColumnDesigner', 700, 560); return false;}\n";
            }
            else
            {
                mJavaScript += "function OpenModalDialog(hdnSelColId, hdnColId) { alert('" + ResHelper.GetString("SelectColumns.EmptyQueryName") + "'); return false;}\n";
            }
        }
        else if (IsClassNames)
        {
            mJavaScript += "function OpenModalDialog(hdnSelColId, hdnColId) { modalDialog('" + ResolveUrl("~/CMSWebParts/Designers/GridColumnDesigner.aspx") + "?classnames=" + hdnProperties.Value + "&SelColId=' + hdnSelColId + '&ColId='+hdnColId ,'GridColumnDesigner', 700, 560); return false;}\n";
        }
        else // Cant find QueryName or ClassNames fiels 
        {
            mJavaScript += "function OpenModalDialog(hdnSelColId, hdnColId) { alert('" + ResHelper.GetString("SelectColumns.EmptyClassNamesAndQueryName") + "');}\n";
        }

        //Register JavaScript
        this.Page.ClientScript.RegisterClientScriptBlock(typeof(string), "SelectColumsGlobal", ScriptHelper.GetScript(mJavaScript));

        this.btnDesign.Text = ResHelper.GetString("SelectColumns.Select");

        // Set to Textbox selected columns
        txtColumns.Text = ConvertXML(hdnSelectedColumns.Value.ToString());
    
    }
    
    protected void Page_Load(object sender, EventArgs e)
    {
    
    }


    ///<summary>Gets or sets field value.</summary>
    public override object Value
    {
        get
        {
            return hdnSelectedColumns.Value;
        }
        set
        {
            hdnSelectedColumns.Value = (string)value;
        }
    }


    /// <summary>
    /// Convert XML to TextBox
    /// </summary>
    /// <param name="mXML">XML document</param>
    public string ConvertXML(string mXML)
    {
        if (DataHelper.GetNotEmpty(mXML, "") == "")
        {
        return "";
        }
            string mToReturn = "";

            XmlDocument mXMLDocument = new XmlDocument();

            mXMLDocument.LoadXml(mXML);

            XmlNodeList NodeList = mXMLDocument.DocumentElement.GetElementsByTagName("column");

            int i = 0;

            foreach (XmlNode node in NodeList)
            {
                if (i > 0) mToReturn += ";";
                mToReturn += XmlHelper.GetXmlAttributeValue(node.Attributes["name"], "");
                i++;
            }

            return mToReturn;
    }
}
