using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.TreeEngine;
using CMS.CMSHelper;

public partial class CMSFormControls_selectdocument : CMS.FormEngine.FormEngineUserControl
{
    protected void Page_Load(object sender, EventArgs e)
    {
        btnSelect.Text = ResHelper.GetString("FormControls_SelectDocument.btnSelect");
        btnSelect.Attributes.Add("onclick","SelectDocumentDialog('" + txtName.ClientID + "','" + hdnNodeGUID.ClientID + "','" + txtName.Text + "'); return false;");

        this.Page.ClientScript.RegisterClientScriptBlock(typeof(string), ScriptHelper.DIALOG_SCRIPT_KEY, ScriptHelper.DialogScript);
        this.Page.ClientScript.RegisterClientScriptBlock(typeof(string), "SelectDocument", ScriptHelper.GetScript("function SelectDocumentDialog(txtClientID,txtNodeGUIDClienID,aliasPath){modalDialog('" + ResolveUrl("~/CMSWebParts/Designers/DocumentSelection.aspx") + "?txtElem=' + txtClientID + '&txtElem1=' + txtNodeGUIDClienID + '&aliasPath=' + aliasPath,'DocumentSelection', 400, 500); return false;}" +
                                                                                                                 "function SelectDocument(aliasPath,nodeGUID,txtClientID,txtNodeGUIDClienID){if((aliasPath != '') && (txtClientID != '') && (nodeGUID != '') && (txtNodeGUIDClienID != '')) { document.getElementById(txtClientID).value = aliasPath; document.getElementById(txtNodeGUIDClienID).value = nodeGUID }return false;}"));
    }

    ///<summary>Gets or sets field value.</summary>
    public override object Value
    {
        get
        {
            return this.hdnNodeGUID.Value;
        }
        set
        {
            if (value != null)
            {
                Guid nodeGuid = ValidationHelper.GetGuid(value, Guid.Empty);
                if (nodeGuid != Guid.Empty)
                {
                    TreeProvider tp = new TreeProvider();
                    CMS.TreeEngine.TreeNode node = tp.SelectSingleNode(nodeGuid, CMSContext.CurrentUser.PreferredCultureCode, CMSContext.CurrentSite.SiteName);
                    if (node != null)
                    {
                        txtName.Text = node.NodeAliasPath;
                    }
                }
            }
            this.hdnNodeGUID.Value = (string)value;
        }
    }
}
