using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.LicenseProvider;

public partial class CMSInstall_LicenseDialog : System.Web.UI.UserControl
{
    private string hostName = HttpContext.Current.Request.Url.Host.ToLower();
    private string fullHostName = HttpContext.Current.Request.Url.Host.ToLower() + (HttpContext.Current.Request.Url.IsDefaultPort ? "" : ":" + HttpContext.Current.Request.Url.Port);

    protected void Page_Load(object sender, EventArgs e)
    {
        lnkSkipLicense.Click += new EventHandler(lnkSkipLicense_Click);

        this.lblLicenseCaption.Text = string.Format(ResHelper.GetFileString("Install.lblLicenseCaption"), fullHostName);

        // License step strings
        this.lblLicenseTip.Text = string.Format(ResHelper.GetFileString("Install.lblLicenseTip"), fullHostName);
        this.lblEnterLicenseKey.Text = ResHelper.GetFileString("Install.lblEnterLicenseKey");
        this.lnkSkipLicense.Text = ResHelper.GetFileString("Install.lnkSkipLicense");
    }

    void lnkSkipLicense_Click(object sender, EventArgs e)
    {
        FormsAuthentication.SetAuthCookie("administrator", false);
        Response.Redirect("~/cmssitemanager/default.aspx?section=sites&action=new");
    }


    /// <summary>
    /// Try to set new license for actual domain
    /// </summary>
    public void SetLicenseKey()
    {
        if (txtLicense.Text == "")
        {
            throw new Exception(ResHelper.GetFileString("Install.LicenseEmpty"));
        }

        LicenseKeyInfo lki = new LicenseKeyInfo(txtLicense.Text, fullHostName);

        switch (lki.ValidationResult)
        {
            case LicenseValidationEnum.Expired:
                throw new Exception(ResHelper.GetFileString("Install.LicenseNotValid.Expired"));
            case LicenseValidationEnum.Invalid:
                throw new Exception(ResHelper.GetFileString("Install.LicenseNotValid.Invalid"));
            case LicenseValidationEnum.NotAvailable:
                throw new Exception(ResHelper.GetFileString("Install.LicenseNotValid.NotAvailable"));
            case LicenseValidationEnum.WrongFormat:
                throw new Exception(ResHelper.GetFileString("Install.LicenseNotValid.WrongFormat"));
            case LicenseValidationEnum.Valid:
                // try to store license into database

                LicenseKeyInfoProvider.SetLicenseKeyInfo(lki);
                break;
        }
    }

    public void SetLicenseExpired()
    {
        this.lblLicenseCaption.Text = string.Format(ResHelper.GetFileString("Install.lblLicenseCaptionExpired"), fullHostName);
    }

}
