CREATE TABLE [CMS_ScheduledTask] (
		[TaskID]               int NOT NULL IDENTITY(1, 1),
		[TaskName]             nvarchar(200) NOT NULL,
		[TaskDisplayName]      nvarchar(200) NOT NULL,
		[TaskAssemblyName]     nvarchar(200) NOT NULL,
		[TaskClass]            nvarchar(200) NULL,
		[TaskInterval]         nvarchar(1000) NOT NULL,
		[TaskData]             ntext NOT NULL,
		[TaskLastRunTime]      datetime NULL,
		[TaskNextRunTime]      datetime NULL,
		[TaskProgress]         int NULL,
		[TaskLastResult]       ntext NULL,
		[TaskEnabled]          bit NOT NULL,
		[TaskSiteID]           int NULL
)
ON [PRIMARY]
TEXTIMAGE_ON [PRIMARY]
ALTER TABLE [CMS_ScheduledTask]
	ADD
	CONSTRAINT [PK__CMS_ScheduledTas__31B762FC]
	PRIMARY KEY
	([TaskID])
	ON [PRIMARY]
IF OBJECT_ID(N'[CMS_ScheduledTask]') IS NOT NULL
	AND OBJECT_ID(N'[CMS_Site]') IS NOT NULL
	AND OBJECT_ID(N'[FK__CMS_Sched__TaskS__32AB8735]') IS NULL
BEGIN
		ALTER TABLE [CMS_ScheduledTask]
			ADD CONSTRAINT [FK__CMS_Sched__TaskS__32AB8735]
			FOREIGN KEY ([TaskSiteID]) REFERENCES [CMS_Site] ([SiteID])
END
CREATE INDEX [IX_CMS_ScheduledTask]
	ON [CMS_ScheduledTask] ([TaskName])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_ScheduledTask_1]
	ON [CMS_ScheduledTask] ([TaskDisplayName])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_ScheduledTask_2]
	ON [CMS_ScheduledTask] ([TaskLastRunTime])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_ScheduledTask_3]
	ON [CMS_ScheduledTask] ([TaskNextRunTime])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_ScheduledTask_4]
	ON [CMS_ScheduledTask] ([TaskEnabled])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_ScheduledTask_5]
	ON [CMS_ScheduledTask] ([TaskSiteID])
	ON [PRIMARY]
