CREATE TABLE [CMS_User] (
		[UserID]                        int NOT NULL IDENTITY(1, 1),
		[UserName]                      nvarchar(100) NOT NULL,
		[FirstName]                     nvarchar(100) NULL,
		[MiddleName]                    nvarchar(100) NULL,
		[LastName]                      nvarchar(100) NULL,
		[FullName]                      nvarchar(200) NOT NULL,
		[Email]                         nvarchar(100) NULL,
		[UserPassword]                  nvarchar(100) NOT NULL,
		[PreferredCultureCode]          nvarchar(10) NULL,
		[PreferredUICultureCode]        nvarchar(10) NULL,
		[UserEnabled]                   bit NOT NULL,
		[UserIsEditor]                  bit NOT NULL,
		[UserIsGlobalAdministrator]     bit NOT NULL,
		[UserIsExternal]                bit NULL
)
ON [PRIMARY]
ALTER TABLE [CMS_User]
	ADD
	CONSTRAINT [PK__CMS_User__0AD2A005]
	PRIMARY KEY
	([UserID])
	ON [PRIMARY]
ALTER TABLE [CMS_User]
	ADD
	CONSTRAINT [UQ__CMS_User__0BC6C43E]
	UNIQUE
	([UserName])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_User_1]
	ON [CMS_User] ([Email])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_User_2]
	ON [CMS_User] ([FullName])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_User_3]
	ON [CMS_User] ([UserPassword])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_User_4]
	ON [CMS_User] ([UserEnabled])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_User_5]
	ON [CMS_User] ([UserIsEditor])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_User_6]
	ON [CMS_User] ([UserIsGlobalAdministrator])
	ON [PRIMARY]
