CREATE TABLE [CMS_WorkflowScope] (
		[ScopeID]               int NOT NULL IDENTITY(1, 1),
		[ScopeStartingPath]     nvarchar(450) NOT NULL,
		[ScopeWorkflowID]       int NOT NULL,
		[ScopeClassID]          int NOT NULL,
		[ScopeSiteID]           int NOT NULL
)
ON [PRIMARY]
ALTER TABLE [CMS_WorkflowScope]
	ADD
	CONSTRAINT [PK__CMS_WorkflowScop__03F0984C]
	PRIMARY KEY
	([ScopeID])
	ON [PRIMARY]
IF OBJECT_ID(N'[CMS_WorkflowScope]') IS NOT NULL
	AND OBJECT_ID(N'[CMS_Class]') IS NOT NULL
	AND OBJECT_ID(N'[FK__CMS_Workf__Scope__04E4BC85]') IS NULL
BEGIN
		ALTER TABLE [CMS_WorkflowScope]
			ADD CONSTRAINT [FK__CMS_Workf__Scope__04E4BC85]
			FOREIGN KEY ([ScopeClassID]) REFERENCES [CMS_Class] ([ClassID])
END
IF OBJECT_ID(N'[CMS_WorkflowScope]') IS NOT NULL
	AND OBJECT_ID(N'[CMS_Site]') IS NOT NULL
	AND OBJECT_ID(N'[FK__CMS_Workf__Scope__05D8E0BE]') IS NULL
BEGIN
		ALTER TABLE [CMS_WorkflowScope]
			ADD CONSTRAINT [FK__CMS_Workf__Scope__05D8E0BE]
			FOREIGN KEY ([ScopeSiteID]) REFERENCES [CMS_Site] ([SiteID])
END
IF OBJECT_ID(N'[CMS_WorkflowScope]') IS NOT NULL
	AND OBJECT_ID(N'[CMS_Workflow]') IS NOT NULL
	AND OBJECT_ID(N'[FK__CMS_Workf__Scope__06CD04F7]') IS NULL
BEGIN
		ALTER TABLE [CMS_WorkflowScope]
			ADD CONSTRAINT [FK__CMS_Workf__Scope__06CD04F7]
			FOREIGN KEY ([ScopeWorkflowID]) REFERENCES [CMS_Workflow] ([WorkflowID])
END
CREATE INDEX [IX_CMS_WorkflowScope]
	ON [CMS_WorkflowScope] ([ScopeStartingPath])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_WorkflowScope_1]
	ON [CMS_WorkflowScope] ([ScopeWorkflowID])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_WorkflowScope_2]
	ON [CMS_WorkflowScope] ([ScopeClassID])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_WorkflowScope_3]
	ON [CMS_WorkflowScope] ([ScopeSiteID])
	ON [PRIMARY]
