-- =============================================
-- Author:		<Author,,Name>
-- Create date: <Create Date,,>
-- Description:	<Description,,>
-- =============================================
CREATE PROCEDURE [Proc_CMS_Site_RemoveDependences] 
	@SiteID int
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;
    BEGIN TRANSACTION;
	-- deletes site's SettingKeys
	DELETE FROM [CMS_SettingsKey] WHERE SiteID=@SiteID;
	-- deletes site's EmailTemplates
	DELETE FROM [CMS_EmailTemplate] WHERE EmailTemplateSiteID=@SiteID;
	-- deletes site's DomainAliases
	DELETE FROM [CMS_SiteDomainAlias] WHERE SiteID=@SiteID;
	-- deletes site's cultures
	DELETE FROM [CMS_SiteCulture] WHERE SiteID=@SiteID;
	-- deletes site's PageTemplates
	DELETE FROM [CMS_PageTemplateSite] WHERE SiteID=@SiteID;
	-- deletes site's Users
	DELETE FROM [CMS_UserSite] WHERE SiteID=@SiteID;
	-- removes Role's dependences when site's Roles are deleted
	DELETE FROM [CMS_UserRole] WHERE RoleID IN (
		SELECT RoleID FROM [CMS_Role] WHERE SiteID=@SiteID
	);
	DELETE FROM [CMS_RolePermission] WHERE RoleID IN (
		SELECT RoleID FROM [CMS_Role] WHERE SiteID=@SiteID
	);
	DELETE FROM [CMS_WorkflowStepRoles] WHERE RoleID IN (
		SELECT RoleID FROM [CMS_Role] WHERE SiteID=@SiteID
	);
	-- deletes site's Roles
	DELETE FROM [CMS_Role] WHERE SiteID=@SiteID;
	-- deletes site's Resources
	DELETE FROM [CMS_ResourceSite] WHERE SiteID=@SiteID;
	-- deletes site's Classes
	DELETE FROM [CMS_ClassSite] WHERE SiteID=@SiteID;
	-- deletes Events of the site
	DELETE FROM [CMS_EventLog] WHERE SiteID=@SiteID;
	-- deletes site's RelationshipNames
	DELETE FROM [CMS_RelationshipNameSite] WHERE SiteID=@SiteID;
	-- deletes site's WorkflowScopes
	DELETE FROM [CMS_WorkflowScope] WHERE ScopeSiteID=@SiteID;
	-- deletes site's CSSStylesheets
	DELETE FROM CMS_CssStylesheetSite WHERE SiteID=@SiteID;
	-- deletes site's InlineControls
	DELETE FROM [CMS_InlineControlSite] WHERE SiteID=@SiteID;
	-- deletes site's ScheduledTasks
	DELETE FROM [CMS_ScheduledTask] WHERE TaskSiteID=@SiteID;
	
	-- removes Newsletter_Subscriber's dependences when site's Newsletter_Subscribers are deleted
	DELETE FROM [Newsletter_Emails] WHERE EmailSubscriberID IN (
		SELECT SubscriberID FROM [Newsletter_Subscriber] WHERE SubscriberSiteID=@SiteID
	);
	DELETE FROM [Newsletter_SubscriberNewsletter] WHERE SubscriberID IN (
		SELECT SubscriberID FROM [Newsletter_Subscriber] WHERE SubscriberSiteID=@SiteID
	);
	-- deletes site's Newsletter_Subscribers
	DELETE FROM [Newsletter_Subscriber] WHERE SubscriberSiteID=@SiteID;
	-- removes Newsletter_Newsletter's dependences when site's Newsletter_Newsletters are deleted
	DELETE FROM [Newsletter_Emails] WHERE EmailNewsletterIssueID IN (
		SELECT IssueID FROM [Newsletter_NewsletterIssue] WHERE IssueNewsletterID IN (
			SELECT NewsletterID FROM [Newsletter_Newsletter] WHERE NewsletterSiteID=@SiteID
		)
	);
	DELETE FROM [Newsletter_NewsletterIssue] WHERE IssueNewsletterID IN (
		SELECT NewsletterID FROM [Newsletter_Newsletter] WHERE NewsletterSiteID=@SiteID
	);
	DELETE FROM [Newsletter_SubscriberNewsletter] WHERE NewsletterID IN (
		SELECT NewsletterID FROM [Newsletter_Newsletter] WHERE NewsletterSiteID=@SiteID
	);
	-- deletes site's Newsletter_Newsletters
	DELETE FROM [Newsletter_Newsletter] WHERE NewsletterSiteID=@SiteID;
	-- removes Newsletter_EmailTemplate's dependences when site's Newsletter_EmailTemplates are deleted
	DELETE FROM [Newsletter_Emails] WHERE EmailNewsletterIssueID IN (
		SELECT IssueID FROM [Newsletter_NewsletterIssue] WHERE IssueTemplateID IN (
			SELECT TemplateID FROM [Newsletter_EmailTemplate] WHERE TemplateSiteID=@SiteID
		)
	);
	DELETE FROM [Newsletter_NewsletterIssue] WHERE IssueTemplateID IN (
			SELECT TemplateID FROM [Newsletter_EmailTemplate] WHERE TemplateSiteID=@SiteID
	);
	-- deletes site's Newsletter_EmailTemplates
	DELETE FROM [Newsletter_EmailTemplate] WHERE TemplateSiteID=@SiteID;
	-- removes CMS_Class's dependences when BizForms are deleted
	DELETE FROM [CMS_Query] WHERE ClassID IN (
		SELECT FormClassID FROM [CMS_Form] WHERE FormSiteID=@SiteID
	);
	-- insert ClassIDs of BizForms into the temporaty table
	SELECT FormClassID INTO [TempTable] FROM [CMS_Form] WHERE FormSiteID=@SiteID;
	-- deletes site's BizForms from CMS_Form
	DELETE FROM [CMS_Form] WHERE FormSiteID=@SiteID;
	-- deletes BizForm's records in CMS_Class
	DELETE FROM [CMS_Class] WHERE ClassID IN (
		SELECT FormClassID FROM [TempTable]
	);
	-- drops temporary table
	DROP TABLE [TempTable];
	COMMIT TRANSACTION;
END
