CREATE PROCEDURE [Proc_CMS_Tree_UpdateChildNodesPath] 
	@OldAliasPath nvarchar(450), 
	@NewAliasPath nvarchar(450),
	@OldSiteID int, 
	@NewSiteID int,
	@NodeLevelChange int
AS
BEGIN
/* Update the version history SiteID */
IF @OldSiteID <> @NewSiteID
	UPDATE CMS_VersionHistory SET NodeSiteId = @NewSiteID WHERE DocumentID IN
		(SELECT DocumentID FROM View_CMS_Tree_Joined 
		 WHERE left(NodeAliasPath, len(@OldAliasPath) + 1) = @OldAliasPath + '/'
			AND	NodeSiteID = @OldSiteID);
/* Update the child nodes path */
UPDATE CMS_Tree SET 
	NodeAliasPath = @NewAliasPath + right(NodeAliasPath, len(NodeAliasPath) - len(@OldAliasPath)), 
	NodeSiteID = @NewSiteID,
	NodeLevel = NodeLevel + @NodeLevelChange
WHERE
	left(NodeAliasPath, len(@OldAliasPath) + 1) = @OldAliasPath + '/'
AND
	NodeSiteID = @OldSiteID
END;
