using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.Newsletter;

public partial class CMSPages_unsubscribe : System.Web.UI.Page
{

    protected void Page_Load(object sender, EventArgs e)
    {
        Guid subscriberGuid = ValidationHelper.GetGuid(Request.QueryString["subscriberguid"], Guid.Empty);
        Guid newsletterGuid = ValidationHelper.GetGuid(Request.QueryString["newsletterguid"], Guid.Empty);
        if ((subscriberGuid != Guid.Empty) && (newsletterGuid != Guid.Empty))
        {
            if (SubscriberProvider.isSubscribed(subscriberGuid, newsletterGuid))
            {
                SubscriberProvider.Unsubscribe(subscriberGuid, newsletterGuid);
                lblInfo.Visible = true;
                lblInfo.Text = ResHelper.GetString("Unsubscribe.Unsubscribed");

                //if subscriber has unsubscribed after some issue, increase number of unsubscribed persons of that issue by 1
                int issueId = ValidationHelper.GetInteger(Request.QueryString["issueid"], 0);
                if (issueId > 0)
                {
                    Issue issue = IssueProvider.GetIssue(issueId);
                    if (issue != null)
                    {
                        issue.IncreaseUnsubscribedNumber();
                        IssueProvider.SetIssue(issue);
                    }
                }
            }
            else
            {
                lblError.Visible = true;
                lblError.Text = ResHelper.GetString("Unsubscribe.NotSubscribed");
            }
        }
        else
        {
            lblError.Visible = true;
            if (subscriberGuid == Guid.Empty)
            {
                lblError.Text += ResHelper.GetString("Unsubscribe.SubscriberDoesNotExist");
            }
            if (newsletterGuid == Guid.Empty)
            {
                lblError.Text += " \n\r " + ResHelper.GetString("Unsubscribe.NewsletterDoesNotExist");
            }
        }
    }
}
