using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Threading;

using CMS.GlobalHelper;


public partial class CMSSiteManager_Administration_System_System : SiteManagerPage
{
    protected void Page_Load(object sender, EventArgs e)
    {
        PageTitle.TitleText = ResHelper.GetString("Administration-System.Header");
        PageTitle.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSSiteManager/Administration/System/system.gif";

        lblAspAccount.Text = ResHelper.GetString("Administration-System.Account");
        lblValueAspAccount.Text = System.Security.Principal.WindowsIdentity.GetCurrent().Name;

        lblAlocatedMemory.Text = ResHelper.GetString("Administration-System.Memory");

        btnClear.Text = ResHelper.GetString("Administration-System.btnClear");
        btnRestart.Text = ResHelper.GetString("Administration-System.btnRestart");

        lblValueAlocatedMemory.Text = GetAllocatedMemory();

        ltlScript.Text = ScriptHelper.GetScript(" function Load() {}");
    
        if ((!Page.IsPostBack) && Request.QueryString["IsRestarted"] != null && Request.QueryString["IsRestarted"] != "" && Request.QueryString["IsRestarted"] == "1")
        {
            lblInfo.Text = ResHelper.GetString("Administration-System.RestartSuccess");
        }
    }


    /// <summary>
    /// Return all alocated memory
    /// </summary>
    /// <returns></returns>
    private string GetAllocatedMemory()
    {
        return GC.GetTotalMemory(true).ToString();
    }

    /// <summary>
    /// Clear unused memory
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnClear_Click(object sender, EventArgs e)
    {
        GC.Collect();
        lblValueAlocatedMemory.Text = GetAllocatedMemory();
        lblInfo.Text = ResHelper.GetString("Administration-System.ClearSuccess");
    }

    /// <summary>
    /// Restart application
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnRestart_Click(object sender, EventArgs e)
    {
        string mQuery = UrlHelper.AddUrlParameter(Request.Url.Query, "IsRestarted", "1");
        
        HttpRuntime.UnloadAppDomain();
        
        if (Request.Url.AbsoluteUri.IndexOf('?') >= 0)
        {
            Response.Redirect(Request.Url.AbsoluteUri.Remove(Request.Url.AbsoluteUri.IndexOf('?'))+ mQuery);
        }
        else
        {
            Response.Redirect(Request.Url.AbsoluteUri.Remove(Request.Url.AbsoluteUri.IndexOf('?'))+ "?" + mQuery);
        }
        
        

        

        
    }

}
