using System;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

using CMS.GlobalHelper;
using CMS.WebFarmSync;

public partial class CMSSiteManager_Administration_WebFarm_WebFarm_Task_List : SiteManagerPage
{



   protected void Page_Load(object sender, EventArgs e)
    {
        PageTitle.TitleText = ResHelper.GetString("WebFarmTasks_List.HeaderCaption");
        PageTitle.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSSiteManager/Administration/WebFarm/WebFarmTasks.gif";

        UniGrid.OnAction += new OnActionEventHandler(uniGrid_OnAction);
        UniGrid.GridView.GridLines = GridLines.Horizontal;

        btnEmptyTasks.Text = ResHelper.GetString("WebFarmTasks_List.EmptyButton");

        UniGrid.GridView.DataBound += new EventHandler(GridView_DataBound);    
       
    }

    void GridView_DataBound(object sender, EventArgs e)
    {
        if (DataHelper.DataSourceIsEmpty(UniGrid.GridView.DataSource))
        {
            btnEmptyTasks.Visible = false;
        }
    }


    /// <summary>
    /// Handles the UniGrid's OnAction event.
    /// </summary>
    /// <param name="actionName">Name of item (button) that throws event.</param>
    /// <param name="actionArgument">ID (value of Primary key) of corresponding data row.</param>
    protected void uniGrid_OnAction(string actionName, object actionArgument)
    {
        if (actionName == "delete")
        {
            // delete object from database
            WebFarmTaskInfoProvider.DeleteWebFarmTaskInfo(Convert.ToInt32(actionArgument));
        }
    }

    /// <summary>
    /// Clear task list
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnEmptyTasks_Click(object sender, EventArgs e)
    {
        WebFarmTaskInfoProvider.DeleteAllTaskInfo();
        Response.Redirect(Request.RawUrl.ToString());
       
    }
}
