using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.LicenseProvider;
using CMS.CMSHelper;

public partial class CMSSiteManager_Licenses_License_New : SiteManagerPage
{
    protected void Page_Load(object sender, EventArgs e)
    {
        lbLicenseKey.Text = ResHelper.GetString("Licenses_License_New.Key");
        rfvLicenseKey.ErrorMessage = ResHelper.GetString("Licenses_License_New.KeyError");
        btnOK.Text = ResHelper.GetString("Licenses_License_New.OK");

        PageTitle.TitleText = ResHelper.GetString("Licenses_License_New.Title");
        PageTitle.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSSiteManager/Licenses/licenses.gif";

        string[,] pageTitleTabs = new string[2, 3];
        pageTitleTabs[0, 0] = ResHelper.GetString("Licenses_License_New.Licenses");
        pageTitleTabs[0, 1] = "~/CMSSiteManager/Licenses/License_List.aspx";
        pageTitleTabs[0, 2] = "";
        pageTitleTabs[1, 0] = ResHelper.GetString("licenses_license_new.new");
        pageTitleTabs[1, 1] = "";
        pageTitleTabs[1, 2] = "";
        PageTitle.Breadcrumbs = pageTitleTabs;
    }


    protected void btnOK_Click(object sender, EventArgs e)
    {
        lblError.Text = "";
        LicenseKeyInfo lk = new LicenseKeyInfo(tbLicenseKey.Text, "");
        if (lk != null)
        {
            switch (lk.ValidationResult)
            {
                case LicenseValidationEnum.Expired:
                    lblError.Text = ResHelper.GetString("Licenses_License_New.LicenseNotValid.Expired");
                    break;
                case LicenseValidationEnum.Invalid:
                    lblError.Text = ResHelper.GetString("Licenses_License_New.LicenseNotValid.Invalid");
                    break;
                case LicenseValidationEnum.NotAvailable:
                    lblError.Text = ResHelper.GetString("Licenses_License_New.LicenseNotValid.NotAvailable");
                    break;
                case LicenseValidationEnum.WrongFormat:
                    lblError.Text = ResHelper.GetString("Licenses_License_New.LicenseNotValid.WrongFormat");
                    break;
                case LicenseValidationEnum.Valid:
                    // try to store license into database
                    try
                    {
                        LicenseKeyInfoProvider.SetLicenseKeyInfo(lk);
                        lblInfo.Text = ResHelper.GetString("General.ChangesSaved");
                        lblInfo.Visible = true;                       
                    }
                    catch (Exception ex)
                    {
                        lblInfo.Visible = false;
                        lblError.Visible = true;
                        if (ex.Message == "[LicenseKeyInfoProvider.SetLicenseKeyInfo]: LicenseDomain already exists.")
                        {
                            lblError.Text = ResHelper.GetString("Licenses_License_New.DomainAlreadyExists").Replace("%%name%%", lk.Domain);
                        }
                    }
                    if (lblInfo.Visible)
                    {
                        Response.Redirect("License_List.aspx");
                    }
                    break;
            }

            if (lblError.Text != "")
            {
                lblInfo.Visible = false;
                lblError.Visible = true;
            }
        }
    }
}
