using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.PortalControls;
using CMS.GlobalHelper;
using CMS.TreeEngine;
using CMS.CMSHelper;
using CMS.SettingsProvider;

public partial class CMSWebParts_Membership_SignOutButton : CMSAbstractWebPart
{
    /// <summary>
    /// Content loaded event handler
    /// </summary>
    public override void OnContentLoaded()
    {
        base.OnContentLoaded();
        SetupControl();
    }


    /// <summary>
    /// Initializes the control properties
    /// </summary>
    protected void SetupControl()
    {
        if ((this.PagePlaceholder.ViewMode == ViewModeEnum.Design) || (this.HideOnCurrentPage) || (!this.IsVisible))
        {
            // Do not process
        }
        else
        {
            btnSignOut.Text = ResHelper.GetString("Webparts_Membership_SignOutButton.SignOut");
        }
        if (CMSContext.CurrentUser != null)
        {
            // if user is not authenticated and ShowOnlyWhenAuthenticated is set
            if ((!CMSContext.CurrentUser.IsAuthenticated()) && (ValidationHelper.GetBoolean(this.GetValue("ShowOnlyWhenAuthenticated"), true)))
            {
                btnSignOut.Visible = false;
            }
        }
    }


    protected void btnSignOut_Click(object sender, EventArgs e)
    {
        if ((this.PagePlaceholder.ViewMode == ViewModeEnum.Design) || (this.HideOnCurrentPage) || (!this.IsVisible))
        {
            // Do not process
        }
        else
        {
            FormsAuthentication.SignOut();
            CMSContext.CurrentUser = null;
            Response.Redirect(DataHelper.GetNotEmpty(this.GetValue("RedirectToURL"), Request.RawUrl));
        }
    }

    ///<summary>Overrides the generation of the SPAN tag with custom tag.</summary>
    protected HtmlTextWriterTag TagKey
    {
        get
        {
            if (CMSContext.CurrentSite != null)
            {
                if (SettingsKeyProvider.GetStringValue(CMSContext.CurrentSite.SiteName + ".CMSControlElement").ToLower().Trim() == "div")
                {
                    return HtmlTextWriterTag.Div;
                }
                else
                {
                    return HtmlTextWriterTag.Span;
                }
            }
            return HtmlTextWriterTag.Span;
        }
    }
}
