-- UPDATE QUERIES
UPDATE [CMS_Query] SET [QueryText]='DELETE FROM CMS_WorkflowHistory WHERE VersionHistoryID IN (SELECT VersionHistoryID FROM CMS_VersionHistory WHERE DocumentID = @DocumentID AND VersionHistoryID NOT IN (SELECT TOP ##WHERE## VersionHistoryID FROM CMS_VersionHistory WHERE DocumentID = @DocumentID ORDER BY VersionHistoryID DESC)); DELETE FROM CMS_VersionHistory WHERE DocumentID = @DocumentID AND VersionHistoryID NOT IN (SELECT TOP ##WHERE## VersionHistoryID FROM CMS_VersionHistory WHERE DocumentID = @DocumentID ORDER BY VersionHistoryID DESC) AND VersionHistoryID NOT IN (SELECT DocumentPublishedVersionHistoryID FROM CMS_Document WHERE DocumentID = @DocumentID AND DocumentPublishedVersionHistoryID IS NOT NULL);' WHERE QueryName='deleteolderversions' 
UPDATE [CMS_Query] SET [QueryText]='SELECT * FROM Newsletter_Newsletter WHERE NewsletterName = @NewsletterName AND NewsletterSiteID = @NewsletterSiteID' WHERE QueryName='selectByNewsletterName'

GO

-- INSERT QUERIES
declare @classid int
set @classid = (SELECT ClassID FROM CMS_Class WHERE ClassName='cms.WebFarmTask')

if @classid<>0
INSERT [CMS_Query] ([QueryName], [QueryTypeID], [QueryText], [QueryRequiresTransaction], [ClassID], [QueryIsLocked]) VALUES ('clearwebfarmservertask', 0, 'DELETE FROM [CMS_WebFarmServerTask]', 0, @classid, 0)

set @classid = (SELECT ClassID FROM CMS_Class WHERE ClassName='cms.pagetemplate')
if @classid<>0
INSERT [CMS_Query] ([QueryName], [QueryTypeID], [QueryText], [QueryRequiresTransaction], [ClassID], [QueryIsLocked]) VALUES ('getPagesForTemplate', 0, 'SELECT [NodeAliasPath],[DocumentCulture],[NodeSiteId],[DocumentUrlPath]  FROM View_PageInfo WHERE PageTemplateCodeName = @CodeName', 0, @classid, 0)

GO

-- INSERT RESOURCE STRINGS
declare @cultureid int
set @cultureid = (SELECT [UICultureID] FROM [CMS_UICulture] WHERE UICultureCode='en-us')

if @cultureid<>0
begin
	declare @resourcestringid int
	INSERT [CMS_ResourceString] ([StringKey], [StringIsCustom]) VALUES ('webfarmtasks_list.emptybutton', 0)
	set @resourcestringid=@@identity
	INSERT [CMS_ResourceTranslation] ([TranslationStringID], [TranslationUICultureID], [TranslationText]) VALUES (@resourcestringid, @cultureid, 'Clear task list')

	INSERT [CMS_ResourceString] ([StringKey], [StringIsCustom]) VALUES ('workflow.subjectreadyforapproval', 0)
	set @resourcestringid=@@identity
	INSERT [CMS_ResourceTranslation] ([TranslationStringID], [TranslationUICultureID], [TranslationText]) VALUES (@resourcestringid, @cultureid, 'Document {%DocumentName%} approved')

	INSERT [CMS_ResourceString] ([StringKey], [StringIsCustom]) VALUES ('templatedesigner.errorminvaluenotinteger', 0)
	set @resourcestringid=@@identity
	INSERT [CMS_ResourceTranslation] ([TranslationStringID], [TranslationUICultureID], [TranslationText]) VALUES (@resourcestringid, @cultureid, 'The Min value field must contain an integer number not less than zero or it must be empty.')

	INSERT [CMS_ResourceString] ([StringKey], [StringIsCustom]) VALUES ('templatedesigner.errormaxvaluenotinteger', 0)
	set @resourcestringid=@@identity
	INSERT [CMS_ResourceTranslation] ([TranslationStringID], [TranslationUICultureID], [TranslationText]) VALUES (@resourcestringid, @cultureid, 'The Max value field must contain an integer number not less than zero or it must be empty.')


	-- UPDATE RESOURCE TRANSLATIONS
	declare @stringid int
	set @stringid=(SELECT [StringID] FROM [CMS_ResourceString] WHERE StringKey='newslettersubscription.firstname')
	UPDATE [CMS_ResourceTranslation] SET [TranslationText]='First&nbsp;Name:' WHERE [TranslationStringID]=@stringid AND [TranslationUICultureID]=@cultureid

	set @stringid=(SELECT [StringID] FROM [CMS_ResourceString] WHERE StringKey='newslettersubscription.lastname')
	UPDATE [CMS_ResourceTranslation] SET [TranslationText]='Last&nbsp;Name:' WHERE [TranslationStringID]=@stringid AND [TranslationUICultureID]=@cultureid
end

GO

-- UPDATE STORED PROCEDURES
ALTER PROCEDURE [Proc_CMS_Site_DeleteRoot]
	@SiteID int
AS
BEGIN
	-- Delete complete site workflow history
	DELETE FROM CMS_WorkflowHistory WHERE 
		VersionHistoryID IN (SELECT VersionHistoryID FROM CMS_VersionHistory WHERE 
			DocumentID IN (SELECT DocumentID FROM CMS_Document WHERE 
				DocumentNodeID IN (SELECT NodeID FROM CMS_Tree WHERE NodeSiteID=@SiteID)));
	-- Delete complete version history
	DELETE FROM CMS_VersionHistory WHERE 
		DocumentID IN (SELECT DocumentID FROM CMS_Document WHERE 
			DocumentNodeID IN (SELECT NodeID FROM CMS_Tree WHERE NodeSiteID=@SiteID));
	-- Delete the document data
	DELETE FROM CMS_Document WHERE 
		DocumentNodeID IN (SELECT NodeID FROM CMS_Tree WHERE NodeSiteID=@SiteID);
	-- Delete root eventlog data
	DELETE FROM CMS_EventLog WHERE NodeID IN (SELECT NodeID FROM CMS_Tree WHERE NodeSiteID=@SiteID);
	-- Delete the node data
	DELETE FROM CMS_Tree WHERE NodeSiteID=@SiteID;
END

GO

ALTER PROCEDURE [Proc_CMS_SqlResourceManager_SelectResourceTranslations]	
AS
BEGIN
	SELECT CMS_ResourceTranslation.*, CMS_ResourceString.StringKey, CMS_UICulture.UICultureCode FROM CMS_ResourceTranslation INNER JOIN CMS_ResourceString ON CMS_ResourceTranslation.TranslationStringID = CMS_ResourceString.StringID INNER JOIN CMS_UICulture ON CMS_ResourceTranslation.TranslationUICultureID = CMS_UICulture.UICultureID
END

GO

-- INSERT EMAIL TEMPLATES
INSERT [CMS_EmailTemplate] ([EmailTemplateName], [EmailTemplateDisplayName], [EmailTemplateText], [EmailTemplateSiteID]) VALUES ('Workflow.ReadyForApproval', 'Document ready for approval', '<html>
	<head>
	</head>
	<body style="FONT-SIZE: 12px; FONT-FAMILY: arial">
		<p>
		This an automatic notification sent by Kentico CMS. The following document is waiting for your approval. Please sign in to Kentico CMS Desk and approve it.
		</p>
		<p>
		<b>Document:</b> <a href="{%applicationurl%}/CMSDesk/default.aspx?section=content&action=edit&nodeid={%nodeid%}">{%documentname%}</a>
		<br>
		<b>Last approved by:</b> {%approvedby%}
		<br>
		<b>Last approved when:</b> {%approvedwhen%}
		<br>
		<b>Original step:</b> {%originalstep%}
		<br>
		<b>Current step:</b> {%currentstep%}
		<br>
		<b>Comment:</b>
		<br>
		{%comment%}
		</p>
	</body>
</html>', NULL)

GO

-- UPDATE EMAIL TEMPLATES
UPDATE [CMS_EmailTemplate] SET [EmailTemplateDisplayName]='Document approved', [EmailTemplateText]='<html>
	<head>
	</head>
	<body style="FONT-SIZE: 12px; FONT-FAMILY: arial">
		<p>
		This an automatic notification sent by Kentico CMS. The following document was approved.
		</p>
		<p>
		<b>Document:</b> <a href="{%applicationurl%}/cmsdesk/default.aspx?section=content&action=edit&nodeid={%nodeid%}">{%documentname%}</a>
		<br>
		<b>Approved by:</b> {%approvedby%}
		<br>
		<b>Approved when:</b> {%approvedwhen%}
		<br>
		<b>Original step:</b> {%originalstep%}
		<br>
		<b>Current step:</b> {%currentstep%}
		<br>
		<b>Comment:</b>
		<br>
		{%comment%}
		</p>
	</body>
</html>' WHERE [EmailTemplateName]='Workflow.Approved'

GO

-- UPDATE WEBPART
UPDATE [CMS_WebPart] SET [WebPartProperties]='<form><field column="WebPartControlID" fieldcaption="ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="HideOnSubPages" fieldcaption="Hide on sub-pages" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><category name="Design" /><field column="RegionTitle" fieldcaption="Editable region title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="RegionType" fieldcaption="Editable region type" visible="true" defaultvalue="HtmlEditor" columntype="text" fieldtype="dropdownlist" allowempty="false" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><options><item value="TextBox" text="Text box" /><item value="TextArea" text="Text area" /><item value="HtmlEditor" text="HTML Editor" /></options></settings></field><field column="DialogWidth" fieldcaption="Editable region width" visible="true" defaultvalue="" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="DialogHeight" fieldcaption="Editable region height" visible="true" defaultvalue="" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><category name="Behavior" /><field column="HtmlAreaToolbar" fieldcaption="HTML editor toolbar set" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="HtmlAreaToolbarLocation" fieldcaption="HTML editor toolbar location" visible="true" defaultvalue="" columntype="text" fieldtype="dropdownlist" allowempty="true" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><options><item value="Out:FCKToolbar" text="Shared toolbar" /><item value="In" text="In-line toolbar" /></options></settings></field><field column="MinLength" fieldcaption="Minimum length" visible="true" defaultvalue="" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="MaxLength" fieldcaption="Maximum length" visible="true" defaultvalue="" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="WordWrap" fieldcaption="Word wrap (text area only)" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><category name="Security" /><field column="CheckPermissions" fieldcaption="Check permissions" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>' WHERE [WebPartName]='editabletext'
